Subject: Re: [PATCH v8 0/8] Rewrite `git_config()` using config-set API

From: Ramsay Jones <[email-masked]>
Date: Mon, 11 Aug 2014 10:59:13 +0100

On 10/08/14 18:29, Junio C Hamano wrote:
> Ramsay Jones <[email-masked]> writes:
> 
>> On 08/08/14 15:07, Tanay Abhra wrote:
>> ...
>>> (cc to Ramsay)
>>>
>>> The discussion in both threads (v8 and v9), boils down to this,
>>> is the `key_value_info` struct really required to be declared public or should be
>>> just an implementation detail. I will give you the context,
>>
>> No, this is not the issue for me. The patch which introduces the
>> struct in cache.h does not make use of that struct in any interface.
>> It *is* an implementation detail of some code in config.c only.
>>
>> I do not know how that structure will be used in future patches. ;-)
> 
> It is debatable if it is a good API that tells the users "In the
> data I return to you, there is a structure hanging there with these
> two fields. Feel free to peek into it if you need what is recorded
> in them".

There is no debate in my mind. ;-)

In this future patch, the movement of the structure out of config.c would
be plain for everyone to see, and (hopefully) debate the merits of such
an 'interface'. Along with checking that it is properly documented. (which
patch should the documentation be in?) Where should it be documented?
 
>              But the contract between the the endgame "API" and its
> callers can include such a direct access, and then you can say that
> it is a part of the API, not just an implementation detail.

Sure. It's just a question of timing and allowing reviewers to see the
actual change in one patch.

> I think you and Tanay are both right (and I am wrong ;-).

;-)

I don't have *very* strong feelings about this, which is why I didn't
respond to the earlier replies by Tanay and Matthieu, but since I was
cc-ed on this thread ... (It seemed to me that my comments had been
misunderstood).

So yes, I think this "API" is ugly and could be improved upon, but I
don't care sufficiently to make any further comment. :-D

ATB,
Ramsay Jones